<!DOCTYPE html>
  <html>
    <head>
        <meta charset="utf-8" />
         <title>2048</title>
          <link rel="stylesheet" type="text/css" href="MonStyle.css" />
    
   </head>
    <body>
    
       <nav>
        <ul>
            <li> <a href="accueil.html">Accueil</a> 
            </li>
            <li> <a href="regles.html">Règles</a> 
            </li>
            <li> <a href="monprojet.html">Mon projet</a> 
            </li>
            </ul>
       </nav>


       <div id="partieprincipalemonprojet">
        <p>Dans cette partie je vais vous parler des diffèrentes fonctions que j'ai utilisé pour mon code du 2048. </p>
        
        <h3> <strong> 1\ La fonction d'initialisation. </strong> </h3>
        <p>Cette fonction était présente au début mais n'était pas fonctionelle. Elle s'appelle <stronger> Init. </stronger> </p>
        <p>Cette fonction prend le rôle du joueur "ordinateur" qui va ajouter une tuile après chaque action du joueur ayant engendré un mouvement sur la grille.<br /> Elle prend en entrée la grille, et renvoie en sortie la grille aprés l'ajout de la nouvelle tuile. </p>
        

         <h3> <strong> 2\ La fonction de fin.</strong> </h3>
         <p>Cette fonction qui ne fonctionnait pas au début s'appelle <stronger> TestFin. </stronger> </p>
         <p>Cette fonction permet de tester si c'est la fin du jeu. En effet soit on arrive au 2048 et on gagne, soit toutes les cases se remplissent sans avoir atteint le 2048 et donc c'est perdu.<br />Elle prend en entrée la grille. Et en sortie elle renvoie soit 1 si c'est gagné, -1 si c'est perdu, 0 sinon.</p>
        

         <h3> <strong> 3\ La fonction d'ajout.</strong> </h3>
         <p>Cette fonction qu'on a crée nous même s'appelle <stronger> Ajout. </stronger> </p>
         <p>Cette fonction permet de tester si c'est la fin du jeu. En effet soit on arrive au 2048 et on gagne, soit toutes les cases se  remplissent sans avoir atteint le 2048 et donc c'est perdu.<br />Elle prend en entrée la grille. Et en sortie elle renvoie soit 1 si c'est gagné, -1 si c'est perdu, 0 sinon.</p>
         
        
         <h3> <strong> 4\ Les fonctions de deplacements.</strong> </h3>
         <p> Ce sont des fonctions qu'on a du changer étant donné qu'elles étaient non fonctionnelles au début.
         
         <h4> <strong> a) Les déplacements droit et gauche.</strong> </h4>
         <p>La foction de déplacement vers la droite s'appelle <stronger> ActionDroit. </stronger></p>
         <p>Cette fonction commence à parcourir la grille par l'avant dernière case en partant par la droite , si la case rencontrée est égale à 0 et que la case suivante est differente de 0 alors je switch les valeurs des deux cases.<br />Elle prend en entrée la grille avant le mouvement (grille). Et en sortie elle renvoie la grille après le mouvement (X), mais également la fonction fusion .</p>
         
         <p>La fonction de déplacement vers la gauche s'appelle<stronger> ActionGauche. </stronger></p>
         <p>Cette fonction se base sur le même principe que le déplacement droit, sauf que cette fois-ci en commençant par la premiere case de la deuxième ligne en partant par la gauche. </p>
         

         <h4> <strong> b) Les déplacements haut et bas</strong> </h4>
         <p>La foction de déplacement vers le haut s'appelle <stronger> ActionHaut. </stronger></p>
         <p>Cette fonction commence à parcourir la grille par l'avant dernière ligne en partant par le haut , si la case rencontrée est égale à 0 et que la case suivante est differente de 0 alors je switch les valeurs des deux cases.<br />Elle prend en entrée la grille avant le mouvement (grille). Et en sortie elle renvoie la grille après le mouvement (X), mais également la fonction fusion.</p>
        
         <p>La fonction de déplacement vers le bas s'appelle<stronger> ActionBas.</stronger></p>
         <p>Cette fonction se base sur le même principe que le déplacement haut, sauf que cette fois-ci on commence à parcourir la grille par l'avant dernière ligne en partant par le bas de la grille</p>

         <h3> <strong> 5\ La fonction de fusion.</strong> </h3>
         <p> Ce sont des fonctions qu'on a du crée, pour pouvoir additionner les diffèrentes tuiles de la grille en fonction des mouvement. Quelque soit le déplacement le mode opératoire est toujours le même: on parcours la grille, si deux cases successives sont égales alors la première case rencontée sera égale à 0 et l'autre sera égale à elle meme *2. <br /> Cette fonction prend en entrée la grille avant la fusion, et renvoie la grille aprés la fusion mais aussi fait appel à la fonction ajout.</p>
         

       </div>
      
          <center>
             <div id="footer">
               <p> Copyright © 2020 All rights reserved </p>
             </div>
          </center>


    </body>

  </html>
  
  	 